<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="mtb__bme680_8h" kind="file" language="C++">
    <compoundname>mtb_bme680.h</compoundname>
    <includes local="yes">bme680.h</includes>
    <includes local="yes">cy_result.h</includes>
    <includes local="yes">cyhal_gpio.h</includes>
    <includes local="yes">cyhal_i2c.h</includes>
    <includes local="yes">cyhal_spi.h</includes>
    <includedby local="yes" refid="mtb__bme680_8c">mtb_bme680.c</includedby>
    <incdepgraph>
      <node id="7">
        <label>cyhal_i2c.h</label>
      </node>
      <node id="4">
        <label>bme680.h</label>
      </node>
      <node id="8">
        <label>cyhal_spi.h</label>
      </node>
      <node id="3">
        <label>mtb_bme680.h</label>
        <link refid="mtb__bme680_8h" />
        <childnode refid="4" relation="include">
        </childnode>
        <childnode refid="5" relation="include">
        </childnode>
        <childnode refid="6" relation="include">
        </childnode>
        <childnode refid="7" relation="include">
        </childnode>
        <childnode refid="8" relation="include">
        </childnode>
      </node>
      <node id="5">
        <label>cy_result.h</label>
      </node>
      <node id="6">
        <label>cyhal_gpio.h</label>
      </node>
    </incdepgraph>
    <innerclass prot="public" refid="structmtb__bme680__t">mtb_bme680_t</innerclass>
    <innerclass prot="public" refid="structmtb__bme680__data__t">mtb_bme680_data_t</innerclass>
      <sectiondef kind="enum">
      <memberdef id="group__group__board__libs_1gae87f0a182b43c473b0b86f6d4c2a05f9" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>mtb_bme680_address_t</name>
        <enumvalue id="group__group__board__libs_1ggae87f0a182b43c473b0b86f6d4c2a05f9a53545237ca2f3eff529d786de7d56627" prot="public">
          <name>MTB_BME680_DEFAULT_ADRESS</name>
          <initializer>= BME680_I2C_ADDR_PRIMARY</initializer>
          <briefdescription>
          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__board__libs_1ggae87f0a182b43c473b0b86f6d4c2a05f9a312a51c91cf9bf89d9ee970afae9681b" prot="public">
          <name>MTB_BME680_SECONDARY_ADRESS</name>
          <initializer>= BME680_I2C_ADDR_SECONDARY</initializer>
          <briefdescription>
          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>mtb_bme680_address_t: </bold><linebreak />Enumeration used for selecting I2C address.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="73" bodyfile="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.h" bodystart="69" column="1" file="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.h" line="70" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gae25f5e83daf838a2449cec746484cda7" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t mtb_bme680_init_i2c</definition>
        <argsstring>(mtb_bme680_t *obj, cyhal_i2c_t *inst, mtb_bme680_address_t address)</argsstring>
        <name>mtb_bme680_init_i2c</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>cyhal_i2c_t *</type>
          <declname>inst</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__board__libs_1gae87f0a182b43c473b0b86f6d4c2a05f9">mtb_bme680_address_t</ref></type>
          <declname>address</declname>
        </param>
        <briefdescription>
<para>Initialize the atmospheric sensor for I2C communication. </para>        </briefdescription>
        <detaileddescription>
<para>Then applies the default configuration settings for both the accelerometer &amp; gyroscope. Known maximum I2C frequency of 3.4MHz; refer to manufacturer's datasheet for confirmation. See: <ref kindref="member" refid="group__group__board__libs_1ga0e63d21b5c46b109e4f31bb542f6e0f9">mtb_bme680_config_default()</ref> <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BME680 object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">inst</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C instance to use for communicating with the BME680 sensor. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">address</parametername>
</parameternamelist>
<parameterdescription>
<para>BME680 I2C address, set by hardware implemntation. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if properly initialized, else an error indicating what went wrong. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="118" bodyfile="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.c" bodystart="98" column="1" file="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.h" line="86" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga86ecdc5dc8235bc1baca1ecd92af0508" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t mtb_bme680_init_spi</definition>
        <argsstring>(mtb_bme680_t *obj, cyhal_spi_t *inst, cyhal_gpio_t pin)</argsstring>
        <name>mtb_bme680_init_spi</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>cyhal_spi_t *</type>
          <declname>inst</declname>
        </param>
        <param>
          <type>cyhal_gpio_t</type>
          <declname>pin</declname>
        </param>
        <briefdescription>
<para>Initialize the atmospheric sensor for SPI communication. </para>        </briefdescription>
        <detaileddescription>
<para>Then applies the default configuration settings for both the accelerometer &amp; gyroscope. See: <ref kindref="member" refid="group__group__board__libs_1ga0e63d21b5c46b109e4f31bb542f6e0f9">mtb_bme680_config_default()</ref> <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BME680 object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">inst</parametername>
</parameternamelist>
<parameterdescription>
<para>I2C instance to use for communicating with the BME680 sensor. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pin</parametername>
</parameternamelist>
<parameterdescription>
<para>GPIO pin connected to BME680 Chip Select. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if properly initialized, else an error indicating what went wrong. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="140" bodyfile="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.c" bodystart="120" column="1" file="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.h" line="98" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga0e63d21b5c46b109e4f31bb542f6e0f9" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t mtb_bme680_config_default</definition>
        <argsstring>(mtb_bme680_t *obj)</argsstring>
        <name>mtb_bme680_config_default</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Configure the motion sensor to a default mode with both accelerometer &amp; gyroscope enabled with a nominal output data rate. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BME680 object. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if properly initialized, else an error indicating what went wrong. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="175" bodyfile="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.c" bodystart="142" column="1" file="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.h" line="106" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1gad2fc6efc5a07bd53736f6a8e4d360e08" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>cy_rslt_t</type>
        <definition>cy_rslt_t mtb_bme680_read</definition>
        <argsstring>(mtb_bme680_t *obj, mtb_bme680_data_t *sensor_data)</argsstring>
        <name>mtb_bme680_read</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structmtb__bme680__data__t">mtb_bme680_data_t</ref> *</type>
          <declname>sensor_data</declname>
        </param>
        <briefdescription>
<para>Reads the current accelerometer &amp; gyroscope data from the motion sensor. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BME680 object. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">sensor_data</parametername>
</parameternamelist>
<parameterdescription>
<para>The accelerometer &amp; gyroscope data read from the motion sensor </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>CY_RSLT_SUCCESS if properly initialized, else an error indicating what went wrong. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="186" bodyfile="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.c" bodystart="177" column="1" file="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.h" line="114" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga454896841d5c8c408d67fe3f318e04a1" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>struct bme680_dev *</type>
        <definition>struct bme680_dev* mtb_bme680_get</definition>
        <argsstring>(mtb_bme680_t *obj)</argsstring>
        <name>mtb_bme680_get</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Gets access to the base motion sensor data. </para>        </briefdescription>
        <detaileddescription>
<para>This allows for direct manipulation of the sensor for any desired behavior. See <ulink url="https://github.com/BoschSensortec/BME680_driver">https://github.com/BoschSensortec/BME680_driver</ulink> for more details on the sensor. <parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BME680 object. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>pointer to the BME680 configuration structure. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="191" bodyfile="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.c" bodystart="188" column="1" file="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.h" line="123" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__board__libs_1ga1416dce65012b87922bafcec0fc4f038" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void mtb_bme680_free</definition>
        <argsstring>(mtb_bme680_t *obj)</argsstring>
        <name>mtb_bme680_free</name>
        <param>
          <type><ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Frees up any resources allocated by the motion_sensor as part of <ref kindref="member" refid="group__group__board__libs_1gae25f5e83daf838a2449cec746484cda7">mtb_bme680_init_i2c</ref> or <ref kindref="member" refid="group__group__board__libs_1ga86ecdc5dc8235bc1baca1ecd92af0508">mtb_bme680_init_spi</ref>. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to a BME680 object. </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="202" bodyfile="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.c" bodystart="193" column="1" file="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.h" line="129" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>Description: This file is the public interface of the BME680 atmospheric sensor. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/**************************************************************************/</highlight></codeline>
<codeline lineno="24"><highlight class="preprocessor">#pragma<sp />once</highlight><highlight class="normal" /></codeline>
<codeline lineno="25"><highlight class="normal" /></codeline>
<codeline lineno="45"><highlight class="preprocessor">#include<sp />"bme680.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="46"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_result.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="47"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_gpio.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="48"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_i2c.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="49"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_spi.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="50"><highlight class="normal" /></codeline>
<codeline lineno="51"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="52"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal" /></codeline>
<codeline lineno="53"><highlight class="normal">{</highlight></codeline>
<codeline lineno="54"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal" /></codeline>
<codeline lineno="57" refid="structmtb__bme680__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal">{</highlight></codeline>
<codeline lineno="59"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">bme680_dev<sp />sensor;</highlight></codeline>
<codeline lineno="60"><highlight class="normal">}<sp /><ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref>;</highlight></codeline>
<codeline lineno="61"><highlight class="normal" /></codeline>
<codeline lineno="63" refid="structmtb__bme680__data__t" refkind="compound"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal" /></codeline>
<codeline lineno="64"><highlight class="normal">{</highlight></codeline>
<codeline lineno="65"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">bme680_field_data<sp />atmo;</highlight></codeline>
<codeline lineno="66"><highlight class="normal">}<sp /><ref kindref="compound" refid="structmtb__bme680__data__t">mtb_bme680_data_t</ref>;</highlight></codeline>
<codeline lineno="67"><highlight class="normal" /></codeline>
<codeline lineno="69"><highlight class="keyword">typedef</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">enum</highlight><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal">{</highlight></codeline>
<codeline lineno="71"><highlight class="normal"><sp /><sp /><sp /><sp />MTB_BME680_DEFAULT_ADRESS<sp />=<sp />BME680_I2C_ADDR_PRIMARY,</highlight></codeline>
<codeline lineno="72"><highlight class="normal"><sp /><sp /><sp /><sp />MTB_BME680_SECONDARY_ADRESS<sp />=<sp />BME680_I2C_ADDR_SECONDARY</highlight></codeline>
<codeline lineno="73"><highlight class="normal">}<ref kindref="member" refid="group__group__board__libs_1gae87f0a182b43c473b0b86f6d4c2a05f9">mtb_bme680_address_t</ref>;</highlight></codeline>
<codeline lineno="74"><highlight class="normal" /></codeline>
<codeline lineno="86"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1gae25f5e83daf838a2449cec746484cda7">mtb_bme680_init_i2c</ref>(<ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref><sp />*obj,<sp />cyhal_i2c_t<sp />*inst,<sp /><ref kindref="member" refid="group__group__board__libs_1gae87f0a182b43c473b0b86f6d4c2a05f9">mtb_bme680_address_t</ref><sp />address);</highlight></codeline>
<codeline lineno="87"><highlight class="normal" /></codeline>
<codeline lineno="98"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1ga86ecdc5dc8235bc1baca1ecd92af0508">mtb_bme680_init_spi</ref>(<ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref><sp />*obj,<sp />cyhal_spi_t<sp />*inst,<sp />cyhal_gpio_t<sp />pin);</highlight></codeline>
<codeline lineno="99"><highlight class="normal" /></codeline>
<codeline lineno="106"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1ga0e63d21b5c46b109e4f31bb542f6e0f9">mtb_bme680_config_default</ref>(<ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="107"><highlight class="normal" /></codeline>
<codeline lineno="114"><highlight class="normal">cy_rslt_t<sp /><ref kindref="member" refid="group__group__board__libs_1gad2fc6efc5a07bd53736f6a8e4d360e08">mtb_bme680_read</ref>(<ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref><sp />*obj,<sp /><ref kindref="compound" refid="structmtb__bme680__data__t">mtb_bme680_data_t</ref><sp />*sensor_data);</highlight></codeline>
<codeline lineno="115"><highlight class="normal" /></codeline>
<codeline lineno="123"><highlight class="keyword">struct<sp /></highlight><highlight class="normal">bme680_dev<sp />*<ref kindref="member" refid="group__group__board__libs_1ga454896841d5c8c408d67fe3f318e04a1">mtb_bme680_get</ref>(<ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref><sp />*obj);</highlight></codeline>
<codeline lineno="124"><highlight class="normal" /></codeline>
<codeline lineno="129"><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__board__libs_1ga1416dce65012b87922bafcec0fc4f038">mtb_bme680_free</ref>(<ref kindref="compound" refid="structmtb__bme680__t">mtb_bme680_t</ref><sp />*<sp />obj);</highlight></codeline>
<codeline lineno="130"><highlight class="normal" /></codeline>
<codeline lineno="131"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="132"><highlight class="normal">}</highlight></codeline>
<codeline lineno="133"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="134"><highlight class="normal" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_BME680/sensor-atmo-bme680/mtb_bme680.h" />
  </compounddef>
</doxygen>